/**************************************************************************\
*								  3DGROUP.H								   *
*																		   *
*			 Data types and functions for 3D perspective drawing		   *
*								Polygon group							   *
*																		   *
*								Version 1.1a							   *
*																		   *
*							  by Stewart Gordon							   *
*							  July-August 1998							   *
\**************************************************************************/
#ifndef __3DGROUP_H
#define __3DGROUP_H

#ifndef __LIST_H
#include <list.h>
#endif

#ifndef __3DVECTOR_H
#include "3dvector.h"
#endif

#ifndef __3DPOLY_H
#include "3dpoly.h"
#endif

// DECLARATIONS
extern view *curview;

// Class group: group of 3D polygons
class group {
protected:
	list<polygon*> polygons;
	bool deletepolys;

	int indexlen;
	polygon **index;

public:
	group(bool dp = FALSE) : indexlen(0), index(NULL), deletepolys(dp) {}
	group(int, polygon*, ...);

	~group();

	void addpoly(polygon& poly) { polygons.add(&poly); }

	void render(const view& = *curview);
	void sort(const view& = *curview);
	void draw(const view& = *curview);
};

#endif
