/**************************************************************************\
*								   LIST.H								   *
*																		   *
*							  Linked list class							   *
*																		   *
*							  by Stewart Gordon							   *
*								  July 1998								   *
\**************************************************************************/
#ifndef __LIST_H
#define __LIST_H

#ifndef __BUFFER_H
#include <buffer.h>
#endif

// class list - ordered list (in effect a variable-length array)
template <class N> class list : public queue<N> {
public:
	list() : queue<N>() {}
	~list() { queue<N>::~queue(); }

	int numitems() const;
	N& operator[](int) const;
};

template <class N>
int list<N>::numitems() const {
	node *current = first;

	for(int ino = 0; ; ino++) {
		if(current == NULL) return ino;
		current = current->next;
	}
}

template <class N>
N& list<N>::operator[](int itemno) const {
	node *current = first;
	for(int ino = 0; ino < itemno; ino++) {
		current = current->next;
	}
	return current->data;
}

#endif