/**************************************************************************\
*								  PALETTE.H								   *
*																		   *
*		Data types and functions for dynamic palette colour selection	   *
*																		   *
*								 Version 1.3							   *
*																		   *
*							  by Stewart Gordon							   *
*							August-September 1998						   *
\**************************************************************************/
#ifndef __PALETTE_H
#define __PALETTE_H

#ifndef __MISCIDS_H
//#include <miscids.h>
#endif

#ifndef __RGBARITH_H
#include "rgbarith.h"
#endif

/*
// Class rgb: red, green, blue colour value
class rgb {
public:
	int red, green, blue;

	rgb() : red(0), green(0), blue(0) {}
	rgb(int r, int g, int b) : red(r), green(g), blue(b) {
		clipmax(); clipmin();
	}

	rgb operator+(rgb) const;
	rgb operator-(rgb) const;
	rgb operator*(rgb) const;
	rgb operator*(float) const;
	//rgb operator/(rgb) const;
	rgb operator/(float f) const { return operator*(1 / f); }

	rgb operator+=(rgb a) { return *this = operator+(a); }
	rgb operator-=(rgb a) { return *this = operator-(a); }
	rgb operator*=(rgb a) { return *this = operator*(a); }
	rgb operator*=(float a) { return *this = operator*(a); }
	rgb operator/=(float a) { return *this = operator/(a); }

	int hue() const;
	int sat() const;
	int val() const { return max(max(red, green), blue); }

	void clipmax();
	void clipmin();
};
*/

// Enum palentrystatus: status of palette entry
enum palentrystatus {
	UNUSED,	// not used
	REUSE,	// ready for reuse
	LAST,	// used in last palette (for anti-flicker purposes)
	INUSE	// in use
};

// Class palentry: entry in dynamic palette
class palentry/*: public rgb*/ {
public:
	int red, green, blue;
	palentrystatus status;

	palentry() : red(0), green(0), blue(0), status(UNUSED) {}
};

// Class palette: dynamic palette
class palette {
	static const int palindex[16];
	const int palmin, pallen;
	int palnext;
	palentry *pal;
public:
	palette(int pmin, int plen)
		  : palmin(pmin), pallen(plen), palnext(pmin) {
		pal = new palentry[pallen];
	}

	~palette() { delete[] pal; }

	void overlap();

	int palcolour(int, int, int);
	int palcolour(rgb col);/* {
		return palcolour(col.red, col.green, col.blue);	// to be changed
	}                        */
};

#endif

