/**************************************************************************\
*								 POLYBASE.H								   *
*																		   *
*			 Data types and functions for 3D perspective drawing		   *
*						 Template for polygon types						   *
*																		   *
*								 Version 1.1							   *
*																		   *
*							  by Stewart Gordon							   *
*							  July-August 1998							   *
\**************************************************************************/
#ifndef __POLYBASE_H
#define __POLYBASE_H

template <class P> class polybase {
protected:
	int numpoints;
	P *polypoints;

public:
	polybase<P>() : numpoints(0), polypoints(NULL) {}
	polybase<P>(int npoints) : numpoints(npoints) {
		polypoints = new P[numpoints + 1];
	}

	~polybase() { if(polypoints != NULL) delete[] polypoints; }

	// Operator [] - point of polygon
	P& operator[](int pno) const {
		return polypoints[pno];
	}

	int numpts() const { return numpoints; }

};

#endif
