/**************************************************************************\
*								   SCRPOLY.H							   *
*																		   *
*			 Data types and functions for 3D perspective drawing		   *
*				   Mapping to screen coordinates and clipping			   *
*																		   *
*								 Version 1.1							   *
*																		   *
*							  by Stewart Gordon							   *
*							  July-August 1998							   *
\**************************************************************************/
#ifndef __SCRPOLY_H
#define __SCRPOLY_H

#ifndef NULL
#include <_null.h>
#endif

#ifndef __GRAPHICS_H
#include <graphics.h>
#endif

#ifndef __POLYBASE_H
#include "polybase.h"
#endif

/*#ifndef __3DVECTOR_H
#include "3dvector.h"
#endif*/

class relpoly;
struct view;

// Struct point
struct scrpoint {
	float x, y;
};

struct intpoint {
	int x, y;
};

// Enum clipside: side to clip
enum clipside { MINVAL, MAXVAL };
enum dimension { X, Y };

// Class scrpoly: polygon in screen coordinates
class scrpoly : public polybase<scrpoint> {
	//int numpoints;
	//scrpoint *polypoints;

	void clipedge(int, clipside, dimension);

public:
	scrpoly() : polybase<scrpoint>() {}
	scrpoly(int npoints) : polybase<scrpoint>(npoints) {}
	scrpoly(const relpoly*, const view&);

	//~scrpoly() { polybase<scrpoint>::~polybase(); }

	int* points();

	void clip(int, int, int, int);
	void draw() {
		int *pts = points();
		drawpoly(numpoints + 1, pts);
		delete[] pts;
	}
	void fill() {
		int *pts = points();
		fillpoly(numpoints, pts);
		delete[] pts;
	}
};

// Class rtdpoly: polygon in screen coordinates as integers (ready to draw)
class rtdpoly : public polybase<intpoint> {
public:
	rtdpoly() : polybase<intpoint>() {}
	rtdpoly(int npoints) : polybase<intpoint>(npoints) {}
	rtdpoly(const scrpoly*);

	//~rtdpoly() { polybase<intpoint>::~polybase(); }

	void draw() { drawpoly(numpoints + 1, (const int*)polypoints); }
	void fill() { fillpoly(numpoints, (const int*)polypoints); }
};

#endif

